%OCV 2008

disp('STRUCTURE AND MOTION with 1D cameras');
disp('EXAMPLE 1 WITH GROUND TRUTH');
disp('Loading OCV_example1');

load OCV_example1;


%retrieve camera centres
C=zeros(2,3);
tmp=null(P1);
C(:,1)=tmp(1:2)/tmp(3);
tmp=null(P2);
C(:,2)=tmp(1:2)/tmp(3);
tmp=null(P3);
C(:,3)=tmp(1:2)/tmp(3);
    

figure
plot(U(1,:),U(2,:),'ro'); hold on;
plot(C(1,:),C(2,:),'g*');

disp('The loaded dataset has 10 2D points (red circles) and ...');
disp('3 camera centres (green stars)');
disp('pause;'); pause;

disp('Let us look at the images for this solution and compute the max error');
maxerr=maxerror(u1,u2,u3,P1,P2,P3,U)

disp('pause;'); pause;

disp('EXERCISE:');
disp('Now it is up to you to solve for camera centres and 2D points for the data in OCV_example2.mat');
disp('with KNOWN rotations R1, R2, R3 using lp_knownrotation.m');

disp('Finally, you should solve for both structure and camera motion in OCV_example3.mat');




