function maxerr=maxerror(u1,u2,u3,P1,P2,P3,U,doplot)

if nargin<8,
    doplot=1;
end


PU1=normc(P1*U);
PU2=normc(P2*U);
PU3=normc(P3*U);

if doplot,
    figure
    disp('measured image points (blue stars)');
    disp('reprojected points (red circles)');
    alpha=0:0.01:2*pi;

    subplot(1,3,1);title('Image 1');hold on;axis square;
    plot(cos(alpha),sin(alpha),'-');
    plot(PU1(1,:),PU1(2,:),'ro');hold on;
    plot(u1(1,:),u1(2,:),'b*');hold on;

    subplot(1,3,2);title('Image 2');hold on;axis square;
    plot(cos(alpha),sin(alpha),'-');
    plot(PU2(1,:),PU2(2,:),'ro');hold on;
    plot(u2(1,:),u2(2,:),'b*');hold on;

    subplot(1,3,3);title('Image 3');hold on;axis square;
    plot(cos(alpha),sin(alpha),'-');
    plot(PU3(1,:),PU3(2,:),'ro');hold on;
    plot(u3(1,:),u3(2,:),'b*');hold on;
end


crossprod1 = u1(1,:).*PU1(2,:)-u1(2,:).*PU1(1,:);
scalarprod1 = diag(u1'*PU1)';
tan_angles1 = crossprod1./scalarprod1;

crossprod2 = u2(1,:).*PU2(2,:)-u2(2,:).*PU2(1,:);
scalarprod2 = diag(u2'*PU2)';
tan_angles2 = crossprod2./scalarprod2;

PU3=P3*U;
crossprod3 = u3(1,:).*PU3(2,:)-u3(2,:).*PU3(1,:);
scalarprod3 = diag(u3'*PU3)';
tan_angles3 = crossprod3./scalarprod3;


maxerr=atan(max(abs([tan_angles1,tan_angles2,tan_angles3])));

