
%TRIANGULATION
load sam_example

drawscene

nbrcones=1;
radius=2;
drawscene

nbrcones=3;
radius=0.5;
drawscene

radius=2;
U = intersect_cones(u,P,radius);

U = linf_triangulation(u(1:2,:),P);

%PANORAMAS

load snowpoints;
im1=imread('snow1.jpg');
im2=imread('snow2.jpg');
figure(1);clf;subplot(1,2,1);
image(im1);
hold on;rita(u1,'g*');
subplot(1,2,2);
image(im2);
hold on;rita(u2,'g*');



H=linf_homography(u1(1:2,:),u2);

u2t=pflat(H*u2);
subplot(1,2,1);
rita(u2t,'ro');

while 1,
    disp('click on a point in image 2');
    x=ginput(1)';
    subplot(1,2,2);
    rita(x,'b+');
    subplot(1,2,1);
    rita(pflat(H*[x;1]),'b+');
end

stitch;





%STRUCTURE AND MOTION WITH KNOWN ROTATIONS

load dino_example;
im=imread('dino.jpg');
figure(1);clf;image(im);hold on;
rita(u{1},'g*')


figure(1);
ureproj=pflat(P{1}*U);
rita(ureproj,'ro');

figure(2);clf;
rita3(U,'r*');
hold on;
for ii=1:36;
c=pflat(null(P{ii}));
rita3(c,'b*');
end
rotate3d on;
