
%stitching of im2 to im1 with homography H

%determinze sizes of images
[m1,n1,slask]=size(im1);
[m2,n2,slask]=size(im2);

%transfer right corner points of image 2 to image 1.
%this will determine the width of panoramic image

c1=pflat(H*[n2;1;1]);
c2=pflat(H*[n2;m2;1]);

m_pan = m1;
n_pan= floor(min(c1(1),c2(1)));

im_pan = zeros(m_pan,n_pan,3,'uint8');

%copy image 1 directly to larger panorama image
im_pan(:,1:n1,:)=im1;

%copy remaining pixels from image 2
invH=inv(H);
for xx=n1+1:n_pan;
    for yy=1:m_pan;
        pt = round(pflat(invH*[xx;yy;1]));
        im_pan(yy,xx,:)=im2(pt(2),pt(1),:);
    end
end

figure(2);clf;
image(im_pan);


