% L-infinity Toolbox
% Version 1.0
% ------------------------------------------
% Globally optimal reconstruction algorithms
% for geometric reconstruction problems
% using the L-infinity norm of reprojection errors.
% ------------------------------------------
% For more info, consult:
%   F. Kahl, "Multiple View Geometry and the L-infinity Norm",
%       in Proc. International Conference on Computer Vision,
%       Beijing, China, 2005.
% or:
%   http://www.maths.lth.se/matematiklth/personal/fredrik/download.html
% ------------------------------------------
% Contents:
%
%   linf_triangulation - triangulation from m views
%   linf_resection - camera resectioning for n points
%   linf_homography - homography estimation from n points
%   linf_knownrotation - structure and motion with known rotational part of
%                        the camera (for example, translating cameras)
%   linf_referenceplane - structure and motion with a reference plane
%
%   --------------------------
%   test - interactive demo of all above algorithm
%   --------------------------
%   rms - computes root mean squares error
%   randrot - creates a random rotation matrix
%   randomdata - creates a random example of cameras and points
%   pflat - dehomogenize homogeneous vector coordinates
%   COPYRIGHT - copyright file
%  
% ----------------------
% (C) 2005 Fredrik Kahl
% ----------------------
help Contents.m



