function [P1,P2,P3]=F2P(F12,F13,F23);

if nargin==1,
  [u,s,v]=svd(F12);
  t = v(:,end);
  T = [0 -t(3) t(2); t(3) 0 -t(1);-t(2) t(1) 0];
  b= t;
  A = rand(3,1)*b'+F12*pinv(T);
  P1= inv(A')*[eye(3) -t];
  P2= [eye(3) zeros(3,1)];
  P3=NaN*zeros(3,4);
else
  % Calculate P1,P2,
  [P1,P2]=F2P(F12);
  % The matrix P3 must fullfill X*P1'*F13*P3*X=0 for all vectors X
  % and X*P2'*F23*P3*X=0 for all vectors X.
  % This implies that both P1'*F13*P3 and P2'*F13*P3 must
  % be skew symmetric
  skevperm = [ ...
  1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0; ...
  0 0 0 0 0 1 0 0 0 0 0 0 0 0 0 0; ...
  0 0 0 0 0 0 0 0 0 0 1 0 0 0 0 0; ...
  0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1; ...
  0 1 0 0 1 0 0 0 0 0 0 0 0 0 0 0; ...
  0 0 1 0 0 0 0 0 1 0 0 0 0 0 0 0; ...
  0 0 0 1 0 0 0 0 0 0 0 0 1 0 0 0; ...
  0 0 0 0 0 0 1 0 0 1 0 0 0 0 0 0; ...
  0 0 0 0 0 0 0 1 0 0 0 0 0 1 0 0; ...
  0 0 0 0 0 0 0 0 0 0 0 1 0 0 1 0; ...
  ];
  M = [ ...
  skevperm*kron(eye(4),P1'*F13); ...
  skevperm*kron(eye(4),P2'*F23); ...
  ];
  [u,s,v]=svd(M);
  P3=reshape(v(:,end),3,4);
end;
