function ccd2matlabf(command)
%CCD2MATLABF: this function is called from CCD2MATLAB. See this function.

%disp(command)
if nargin == 0 
	command = 'new'; 
end 

global im
global map
default_nr_of_images 	= 10;
default_nr_of_skip   	= 1;
image_window		= 0;
nr_of_skip		= 1;
fake_run 		= 0;

%% get handles
if 0 == (strcmp(lower(command),'new') |  strcmp(lower(command),'fake'))
	%disp('hmtar handles');
	handle_list = get(gcf,'userdata');
	if length(handle_list) > 0 
		OPCOMFIG	= handle_list(1);
		grab		= handle_list(2);
		show_im		= handle_list(3);
		play_movie	= handle_list(4);
		edit1     	= handle_list(5); 
		grab_nr_slider 	= handle_list(6);
		skip_inc	= handle_list(7); 
		skip_dec 	= handle_list(8); 
		nr_of_im_num 	= handle_list(9); 
		nr_of_skip_num 	= handle_list(10);
		show_slider	= handle_list(11);
		show_nr_txt	= handle_list(12);
		show_nr_num	= handle_list(13);
	end 
end

if strcmp(lower(command),'fake') | strcmp(lower(command),'new')
	OPCOMFIG = figure( 'Name', 'ccd2matlabf control', ...
		'Color', [0 0 1],...
		'Position', [898,4,250,700], ...
		'Pointer', 'crosshair', ...
		'NumberTitle', 'off', ...
		'Resize', 'on');
	set(gca,'visible','off');

	%% POSITION: x y w h
	dy = 0.03;
	dx = 0.6;
	x  = 0.2;
	blue	= [0.7 0.7 0.7];
	white	= [0 0 0];
	red	= [1 0 0];

	param_txt = text(... 
		'Color',[1 1 1],... 
		'EraseMode','normal',... 
		'Position',				[0.0 1.05],...
		'Units','normalized',...
		'Rotation',0 ,...
		'FontSize', 15,...
		'FontWeight', 'bold',...
		'String', 'parameters:');
	edit1 = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''edit1'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.9 dx dy ],... 
		'String','filename',... 
		'Style','edit',... 
		'Units','normalized',... 
		'Visible','on',... 
		'UserData',['edit1']);
	grab_nr_slider = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''grab_nr_slider'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.8 dx dy ],... 
		'String',' ',... 
		'Style','slider',... 
		'Units','normalized',...
		'Max', 100,...
		'Min', 1,...
		'Value', default_nr_of_images,...
		'Visible','on');
	nr_of_im_txt = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[x-0.1 0.82],...
		'Units','normalized',...
		'Rotation',0 ,... 
		'String','nr of images:');
	nr_of_im_num = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[x+0.4 0.82],...
		'Units','normalized',...
		'Rotation',0 ,... 
		'String', num2str(default_nr_of_images));
	skip_dec = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''skip_dec'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.7 0.05 dy ],... 
		'String','-',... 
		'Style','pushbutton',... 
		'Units','normalized',...
		'Max', 100,...
		'Min', 0,...
		'Value', default_nr_of_skip,...
		'Visible','on');
	skip_inc = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''skip_inc'');',... 
		'ForegroundColor',white,... 
		'Position',				[x+0.2 0.7 0.05 dy],... 
		'String','+',... 
		'Style','pushbutton',... 
		'Units','normalized',...
		'Max', 100,...
		'Min', 0,...
		'Value', default_nr_of_skip,...
		'Visible','on');
	nr_of_skip = 1;
	nr_of_skip_txt = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[0.1 0.7],...
		'Units','normalized',...
		'Rotation',0 ,... 
		'String','store every # frame:');
	nr_of_skip_num = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[0.85 0.7],...
		'Units','normalized',...
		'Rotation',0, ...
		'userdata', nr_of_skip, ...
		'String', num2str(default_nr_of_skip));
	show_slider = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''show_slider'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.58 dx dy ],... 
		'String',' ',... 
		'Style','slider',... 
		'Units','normalized',...
		'Max', 100,...
		'Min', 1,...
		'Value', 1,...
		'Visible','off');
	show_nr_txt = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[x-0.1 0.54],...
		'Units','normalized',...
		'Rotation',0 ,... 
		'String','show image nr:',...
		'Visible','off');
	show_nr_num = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[x+0.5 0.54],...
		'Units','normalized',...
		'Rotation',0 ,... 
		'String', num2str(1),...
		'Visible','off');
	action_txt = text(... 
		'Color',[1 1 1 ],... 
		'EraseMode','normal',... 
		'Position',				[0.0 0.4],...
		'Units','normalized',...
		'Rotation',0 ,...
		'FontSize', 15,...
		'FontWeight', 'bold',...
		'String', 'actions:');
	grab = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''grab'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.35 dx dy],... 
		'String','Grab image sequence',... 
		'Style','pushbutton',... 
		'Units','normalized',...
		'userdata', [image_window fake_run], ...
		'Visible','on');
	show_im = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''show_im'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.30 dx dy],... 
		'String','Show image',... 
		'Style','pushbutton',... 
		'Units','normalized',...
		'Visible','off');	
	play_movie = uicontrol(... 
		'BackgroundColor',blue,... 
		'CallBack','ccd2matlabf(''play_movie'');',... 
		'ForegroundColor',white,... 
		'Position',				[x 0.25 dx dy],... 
		'String','Play movie',... 
		'Style','pushbutton',... 
		'Units','normalized',...
		'Visible','off');	

	quit = uicontrol(... 
		'BackgroundColor',blue ,... 
		'CallBack','ccd2matlabf(''quit'');',... 
		'ForegroundColor',white,... 
		'Position',				[0.2 0.1 0.30 dy],... 
		'String','Quit',... 
		'Style','pushbutton',... 
		'Units','normalized',... 
		'Visible','on');

	set(gcf, 'userdata', ...
		[OPCOMFIG grab show_im play_movie edit1 grab_nr_slider ...
		skip_inc skip_dec nr_of_im_num nr_of_skip_num ...
		show_slider show_nr_txt show_nr_num]);

elseif strcmp(lower(command),lower('grab'))
	grab_userdata = get(grab, 'userdata');
	image_window	= grab_userdata(1,1);
	fake_run	= grab_userdata(1,2);
	filename = get(edit1, 'String');
	nr_of_images = round(get(grab_nr_slider, 'Value'));
	unix_command = sprintf('seq_grab -o %s.jpg -f %d -i %d\n',...
			filename, nr_of_images, nr_of_skip);
	if (~fake_run)
		[status, result] = unix(unix_command);
	else
		status = 0; % ***** FAKE RUN *****
	end
	if status == 0
		unix_command = sprintf('split_movie %s.jpg\n', filename);
        	fprintf(1,'\tTranslating images...\n');
		if ~fake_run
        		[status, result] = unix(unix_command);
		else
			status = 0; % ***** FAKE RUN *****
		end
		if status == 0
       			fprintf(1,'\tPreparing an image window.\n');
			image_window = figure ( ...
					'Name', 'ccd2matlab image window', ...
					'Color', [0 0 1],...
					'NumberTitle', 'off', ...
					'Resize', 'off' );
			title('No image so far.');
			set(grab,'userdata', [image_window fake_run]);
			set(show_im, 	 'Visible', 'on');
			set(show_slider, 'Visible', 'on');
			set(show_nr_txt, 'Visible', 'on');
			set(show_nr_num, 'Visible', 'on');
			set(play_movie,  'Visible', 'on');
		end
	end
elseif strcmp(lower(command),lower('show_im'))
	image_nr 		= round(get(show_slider, 'Value'));
	grab_userdata = get(grab, 'userdata');
	image_window	= grab_userdata(1,1);
	fake_run	= grab_userdata(1,2);
	if image_nr <= round(get(grab_nr_slider, 'Value'))
		if (~fake_run)
			gif_file = sprintf('%s_%d.gif', ...
					get(edit1, 'String'),image_nr);
		else
			gif_file = sprintf(...
		'/usr/matematik/vision/images/kalle_%d.gif',image_nr);
		end
  		fprintf(1,'\tDisplaying an image\n');
		figure(image_window);
		[im,map]=gifread(gif_file);
		colormap(map);
		imagesc(im);
		title(gif_file);
	else
		set(show_im, 'Visible', 'off');
	end
elseif strcmp(lower(command),lower('play_movie'))
	gif_files = sprintf(...
		'/usr/matematik/vision/images/kalle_*.gif',image_nr);
	unix_command = sprintf('xanim %s >& /dev/null &\n', gif_files);
	str1 = sprintf('\n\tHang on, loading...\n');
	str2 = sprintf('\tThe image sequence coming soon to a window near you.\n');
	disp([str1 str2]);
	[status, result] = unix(unix_command);
	str1 = sprintf('\tPlace pointer in the new window and control the movie:\n');
	str2 = sprintf('\t\tLeft button: step back\n\t\tRight button: step forward\n');
	str3 = sprintf('\t\tMiddle button: start/stop movie\n');
	str4 = sprintf('\t\tPress "q" to quit the movie program.\n');
	disp([str1 str2 str3 str4]);
elseif strcmp(lower(command),lower('edit1'))
	%disp('edit.')
elseif strcmp(lower(command),lower('grab_nr_slider'))
	nr_of_images = round(get(grab_nr_slider, 'Value'));
	set(nr_of_im_num, 'String', num2str(nr_of_images));
elseif strcmp(lower(command),lower('skip_dec'))
	nr_of_skip = get(nr_of_skip_num, 'userdata');
	if nr_of_skip > 0
		nr_of_skip = nr_of_skip - 1;
	end
	set(nr_of_skip_num, 'userdata', nr_of_skip);
elseif strcmp(lower(command),lower('skip_inc'))
	nr_of_skip = get(nr_of_skip_num, 'userdata');
	if nr_of_skip < 100
		nr_of_skip = nr_of_skip + 1;
	end
	set(nr_of_skip_num, 'userdata', nr_of_skip);
elseif strcmp(lower(command),lower('show_slider'))
	image_nr     = round(get(show_slider, 'Value'));
	nr_of_images = round(get(grab_nr_slider,     'Value'));
	set(show_nr_num, 'String', num2str(image_nr));
	if image_nr > nr_of_images
		set(show_im, 'Visible', 'off');
	else
		set(show_im, 'Visible', 'on');
	end
elseif strcmp(lower(command),lower('quit'))
	close;close;close;
	disp('	Bye');
else 
	error('Error: ccd2matlabf.m called with incorrect command.') 
end

if (strcmp(lower(command),lower('skip_dec'))) | ...
   (strcmp(lower(command),lower('skip_inc')))
	%disp('hepp')
	nr_of_skip = get(nr_of_skip_num, 'userdata');
	set(nr_of_skip_num, 'String', num2str(nr_of_skip));
end

if strcmp(lower(command),lower('fake'))
	disp('	*** fake run ***')
	fake_run = 1;
	set(grab, 'userdata', [image_window fake_run]);
end
