% Denna funktion lagrar varje hrns koordinater, samt dess CornerResponse-
% vrdet i tre vektorer. Hrnen r numrerade s att informationen till hrnet
% lngst upp till vnster i bilden hamnar verst i respektive vektor och hrnet
% lngst ner till hger hamnar sist vektorerna.
%
% Insignaler: 	EWM=en matris med CRF-vrdet p de positioner dr hrn
% 		finns och i vrigt 0. Hrn r de pixlar som har ett CRF-vrde
%		strre n en viss trskel samt r ett lokalt maximum vid
%		jmfrelse med sina 8 grannar.
%		Den kommer ifrn funktionen EightWayMax.
%
% Utsignaler:	CDx=en vektor innehllande hrnens x-koordinater.
%		CDy=en vektor innehllande hrnens y-koordinater.
%		CDf=en vektor innehllande hrnens CRF-vrden.
%
% [CDx,CDy,CDf]=CornerData(EWM)



function [CDx,CDy,CDf]=CornerData(EWM)

CDx=[0];
CDy=[0];
CDf=[0];
[Row,Col]=size(EWM);

for R=1:Row
 for C=1:Col
  if EWM(R,C)~=0
   CDx=[CDx;R];
   CDy=[CDy;C];
   CDf=[CDf;EWM(R,C)];
  end;
 end;
end; 
k=size(CDx);
CDx=CDx(2:k,:);
CDy=CDy(2:k,:);
CDf=CDf(2:k,:);
