% Denna funktion skapar en matris med CRF-vrdet (dvs vrdet som avgr om
% motsvarande pixel r ett hrn eller ej) p de positioner som har ett CRF-
% vrde strre n en viss trskel Threshold, samt r ett lokalt maximum vid
% jmfrelse med sina 8 grannars CRF-vrde. vriga element i matrisen fr
% vrdet 0.
%
% Insignaler: 	CRF=CornerResponseFunction, som anger alla pixlars hrnstyrka
%         	och kommer frn funktionen CornerResponse.
%
%		Threshold=Trskel som avgr om en pixel ska klassas som ett
%		hrn eller ej och matas in frn huvudprogrammet.
%
% Utsignaler:	EWM=en matris med CRF-vrde p de positioner som har ett CRF-
% 		vrde strre n en viss trskel Threshold, samt r ett lokalt
%		maximum vid jmfrelse med sina 8 grannars CRF-vrde.
%
% [EWM]=EightWayMax(CRF,Threshold)





function [EWM]=EightWayMax(CRF,Threshold)

[Row,Col]=size(CRF);

EWM=zeros(Row,Col);


EWM(2:Row-1,2:Col-1) = (CRF(2:Row-1,2:Col-1) > CRF(1:Row-2,2:Col-1));
EWM(2:Row-1,2:Col-1) = EWM(2:Row-1,2:Col-1)  & (CRF(2:Row-1,2:Col-1) > CRF(3:Row,2:Col-1));
EWM(2:Row-1,2:Col-1) = EWM(2:Row-1,2:Col-1)  & (CRF(2:Row-1,2:Col-1) > CRF(1:Row-2,1:Col-2));
EWM(2:Row-1,2:Col-1) = EWM(2:Row-1,2:Col-1)  & (CRF(2:Row-1,2:Col-1) > CRF(3:Row,1:Col-2));
temp=EWM;
EWM(2:Row-1,2:Col-1) = EWM(2:Row-1,2:Col-1)  & (CRF(2:Row-1,2:Col-1) > CRF(1:Row-2,3:Col));
EWM(2:Row-1,2:Col-1) = EWM(2:Row-1,2:Col-1)  & (CRF(2:Row-1,2:Col-1) > CRF(3:Row,3:Col));
EWM(2:Row-1,2:Col-1) = EWM(2:Row-1,2:Col-1)  & (CRF(2:Row-1,2:Col-1) > CRF(2:Row-1,1:Col-2));
EWM(2:Row-1,2:Col-1) = (EWM(2:Row-1,2:Col-1) & (CRF(2:Row-1,2:Col-1) > CRF(2:Row-1,3:Col))).*CRF(2:Row-1,2:Col-1);

CornerEqualizer=EWM > ones(Row,Col)*Threshold;
EWM=EWM.*CornerEqualizer;	

EWM(1:5,:)=0;
EWM(Row-4:Row,:)=0;
EWM(:,1:5)=0;
EWM(:,Col-4:Col)=0;




