% Denna funktion berknar hur mycket respektive punkt i bilden
% motsvarar ett hrn enligt Harris hrndetektionsteori.
%
% Insignaler: 	InImage=inbild som matas in frn huvudprogrammet
%
%		CornerFactor=en trskel fr hur olika egenvrdena lambda1 och
%		lambda2 maximalt fr vara i Harris algoritm. Fr att
%		CornerResponseFunction ska ge ett hgt vrde fr en pixel ska
%		dessa egenvrden vara stora och ungefr lika.
%
% Utsignaler:	CRF=CornerResponseFunction r en matris med ett vrde fr varje
%		pixel. Detta vrde avgr om motsvarande pixel br betraktas
%		som ett hrn eller ej.
%
% [CRF]=CornerResponse(InImage,CornerFactor)
%




%function [CRF,dx,dy,Wxx,Wxy,Wyy]=CornerResponse(InImage,CornerFactor)
function [CRF]=CornerResponse(InImage,CornerFactor)
s1=1;              %s1=sigma=smoothing factor%
subsize1=3;    %subsize bestmmer filterstorleken, samband s1 vs subsize? 
[X,Y]=meshgrid(-subsize1:subsize1,-subsize1:subsize1);
filtdx=-X.*exp(-(X.^2 + Y.^2)/(2*s1^2))/(2*s1^4*pi);
filtdy=-Y.*exp(-(X.^2 + Y.^2)/(2*s1^2))/(2*s1^4*pi);
dx=conv2(InImage,filtdx,'same');%dx=matris med varje bildpunkts x-derivata%
dy=conv2(InImage,filtdy,'same');



s2=2;
subsize2=4;
[X,Y]=meshgrid(-subsize2:subsize2,-subsize2:subsize2);
filt=exp(-(X.^2 + Y.^2)/(2*s2^2))/(2*s2^2*pi);

Wxx=conv2(dx.*dx,filt,'same'); %Wxx=(dI/dx)^2 berknad fr varje bildpunkt,dock med omgivande punkters motsvarande vrde invgt

Wxy=conv2(dx.*dy,filt,'same');
Wyy=conv2(dy.*dy,filt,'same');

Wdet=Wxx.*Wyy-Wxy.^2;
Wtr=Wxx+Wyy;

CRF = (CornerFactor+1/CornerFactor)*abs(Wdet)-abs((Wtr.^2)-2*Wdet);

[Row,Col] = size(CRF);
NullCRF = zeros(Row,Col);
TempCRF = CRF > NullCRF;
CRF = CRF.*TempCRF;

