function [F,bild1kor,bild2kor]=hittabilinjar(bild1,bild2,metod,mangfald)
% [F,bild1kor,bild2kor]=hittabilinjar(bild1,bild2,metod) raknar
% ut bilinjara sambandet mellan tva bilder bild1 och bild2
% som forutsatts vara olika bilder av samma objekt.

% metod : 1 - enkel linjr metod.


if         (nargin  < 2),
  error('hittabilinjar krver minst tv argument');
  help hittabilinjar
elseif      (nargin == 2)
  metod = 1;
elseif      (nargin == 3)
  mangfald = 1;
elseif      (nargin == 4)

else
  error('simulerabilder only takes 1 argument.');
end;

if metod == 1,
% Den enklaste linjra metoden.
 M=[ diag(bild1(1,:))*(bild2') diag(bild1(2,:))*(bild2') diag(bild1(3,:))*(bild2') ];
 [u,s,v]=svd(M);
 f=v(:,9)';
 F1=[f(1,1:3);f(1,4:6);f(1,7:9)];
 if mangfald == 1,
  [u,s,v]=svd(F1);
  s(3,3)=0;
  F=u*s*v';
  F=F/norm(F);
 elseif mangfald == 2,
  [u,s,v]=svd(F1);
  s(3,3)=0;
  s(1,1)=1;
  s(2,2)=1;
  F=u*s*v';
  F=F/norm(F);
  bild2t=s*v'*bild2;
  argu2=atan2(bild2t(2,:),bild2t(1,:));
  bild1t=s*u'*bild1;
  argu1=atan2(bild1t(2,:),bild1t(1,:));
  normangle(argu2-argu1)
  if (mean(normangle(argu2-argu1)) < 0)
    F=-F;
  end;
 elseif mangfald == 3,
  [n,m]=size(bild1);
  x1= [ones(n,1) bild1];
  x2= [ones(n,1) bild2];
  m1=x1(1:3,1:3);
  m2=x2(1:3,1:3);
  x1=x1*inv(m1);
  x2=x2*inv(m2);
  %x1=bild1;
  %x2=bild2;
  mat=[];
  for i=4:n
    if (isnan(x1(i,2))+isnan(x2(i,2)))==0 
      mat=[mat ; x1(i,1)*x2(i,2) x1(i,1)*x2(i,3) x1(i,2)*x2(i,1)...
                 x1(i,2)*x2(i,3) x1(i,3)*x2(i,1) x1(i,3)*x2(i,2)];
    end;
  end;
  [u,s,v]=svd(mat);
  tvekt=v(:,6);
  F=[0 tvekt(1) tvekt(2);tvekt(3) 0 tvekt(4);tvekt(5) tvekt(6) 0]; 
 elseif mangfald == 3,

 else
  F=F1;
 end;
end;

%Kalle strm och Anders Heyden, Matematiska Institutionen, LTH
%email: kalle@maths.lth.se, andersp@maths.lth.se
%Version 0.0 950220
