function out_image = hough(in_image, angles);

% HOUGH Makes a Houghtransform of a matrix, interpreted as an image.
%	The image should preferably be binary, but works also with 
%	0-255 graylevel images (slow!). 
%
%	HOUGH(image) returns the transformed image, with a width of 
%	180 pixels (one pixel per degree).
%	HOUGH(image, angles) returns the transformed image, with a 
%	width of 'angles' pixels.
%	The resulting image has a height equal to half the diagonal 
%	of the input image.   

if nargin < 1, error('Too few input arguments.'); end
im_size = size(in_image);
if im_size(1) == 1 | im_size(2) == 1,
  error('Input argument nr 1 must be a matrix.');
end
if nargin == 2,
  an_size = size(angles);
  if an_size(1) ~= 1 & an_size(2) ~= 1,
    error('Input argument nr 2 must not be a matrix.');
  end
  if angles < 1, error('Number of angles must be positive.'); end
end

format long
temp_file_name1 = ['temp_file' num2str(rand)];
temp_file_name2 = ['temp_file' num2str(rand)];
format short

savepgm(in_image, temp_file_name1);
eval(['!/usr/matematik/vision/bin/pgmhough ' temp_file_name1 ' > ' temp_file_name2]);
out_image = readpgm(temp_file_name2);
eval('!rm -f temp_file?.*');


