
function [t,R]=invessentialm2(E);
% [t,R]=invessentialm2(E) - decompose the essential matrix
% into a unit direction t and a R rotation matrix so that
% E=essentialm(t,R) (up to scale)

P=[0  1 0;-1 0 0; 0 0 -1]; % perm. matrix
Q=[0 -1 0; 1 0 0; 0 0 0]; % cross matrix

[u,s,v]=svd(E);

s1=s(1,1);
s2=s(2,2);
if abs (s1-s2)>1e-3,
  disp('Error');
else
  % s(3,3) should be zero
  s3 = s2; % to make S full rang
  % F = u*P*Q*inv(u*P)*u*P*diag([s1 s2 s3])*v'

  T= u*P*Q*inv(u*P);
  t=[ T(3,2) T(1,3) T(2,1)]';
  R=u*P*diag([1 1 det(u)*det(v)])*v';
end


