
function [t,S]=invfundamentalm(F);
% [t,S]=invfundamentalm(E) - decompose the fundamental matrix
% into a unit direction t and a S matrix

P=[0  1 0;-1 0 0; 0 0 -1]; % perm. matrix
Q=[0 -1 0; 1 0 0; 0 0 0]; % cross matrix

[u,s,v]=svd(F);

s1=s(1,1);
s2=s(2,2);
% s(3,3) should be zero
s3 = s2; % to make S full rang
% F = u*P*Q*inv(u*P)*u*P*diag([s1 s2 s3])*v'

T= u*P*Q*inv(u*P);
t=[ T(3,2) T(1,3) T(2,1)]';
S=u*P*diag([s1 s2 s3])*v';
