function [bilddata,bildindex,objekt,projdata,projindex]= ...
           simulerabilder(metod,antalpunkter,antalbilder);
%  [bilddata,bildindex,objekt,projdata,projindex] =
%           simulerabilder(metod,antalpunkter,antalbilder);
% simulerabilder skapar en sekvens av bilder fran olika
% punkter i rummet av ett objekt.
% metod 1 - objekt punkternas x, y och z koordinater rektangelfrdelade
%           mellan noll och ett. Kameran ovanfr z=0 planet.
% metod 2 - som metod 1 men de fyra frsta punkterna i ett plan.
% metod 3 - 2D version: Objekten placeras runt cirka 10-15 frn origo
%           och rorelsen ar inom en radie av 10, kalibrerad kamera.

if         (nargin  < 1),
 metod        = 1;
 antalpunkter = 1;
 antalbilder  = 1;
elseif (nargin == 1)
 antalpunkter = 1;
 antalbilder  = 1;
elseif (nargin == 2)
 antalbilder  = 1;
elseif (nargin == 3)

else
  error('simulerabilder only takes 1 argument.');
end;

[bilddata,bildindex]=nyml;
[projdata,projindex]=nyml;
objekt=[];

if (metod==1 | metod==2),
 if metod==2, antalpunkter = max(antalpunkter,4); end;
 [bilddata,bildindex]=nyml;
 [projdata,projindex]=nyml;
 objekt=[rand(3,antalpunkter); ones(1,antalpunkter)];
 if metod==2, objekt(1:4,1:4)=[0 0 0 1;1 0 0 1;1 1 0 1;0 1 0 1]'; end;
 for i = 1:antalbilder,
   t=rand(3,1);
   t(3,1)=rand+1;
   t=(4+rand*3)*t/norm(t);
   R=randrot(-t+randn(3,1)*0.8);
   proj=[R -R*t];
   proj=proj/norm(proj);
   bild=psphere(proj*objekt);
   [projdata,projindex]=laggtillml(projdata,projindex,proj);
   [bilddata,bildindex]=laggtillml(bilddata,bildindex,bild);
 end;
end;

if (metod==3),
 [bilddata,bildindex]=nyml;
 [projdata,projindex]=nyml;
 objekt=zeros(3,antalpunkter);
 for i = 1:antalpunkter;
  rikt=randn(2,1); rikt=rikt/norm(rikt);
  objekt(1:3,i)=[(10+5*rand)*rikt; 1];
 end;
 for i = 1:antalbilder,
   t=rand(2,1);
   t=(4+rand*3)*t/norm(t);
   th=rand*2*pi;
   R=[cos(th) sin(th);-sin(th) cos(th)];
   proj=[R -R*t];
   proj=proj/norm(proj);
   bild=psphere(proj*objekt);
   [projdata,projindex]=laggtillml(projdata,projindex,proj);
   [bilddata,bildindex]=laggtillml(bilddata,bildindex,bild);
 end;
end;
