function [alfa,p,xa,ya] = xy2alfap(x,y,metod)
% [alfa,p,xa,ya] = xy2alfap(x,y,metod)
% Rkna ut djup alfa och projektionsmatris p som hr
% till punktkonfigurationen x och bilden y, d v s s att
%        y*diag(alfa) \approx p*x
% eller ya*diag(alfa) = p x s att
%       ya \approx y           och
%       xa \approx x
% Invariabler: x - Objekt. Punktkonfiguration i homogena koordinater
%                  Varje kolumn r en punkt.
%              y - Objekt. Punktkonfiguration i homogena koordinater
%                  Varje kolumn r en punkt.
%              metod - anger vilken metod som skall anvndas.
%                1: enkel linjr shape baserad metod.
%                2: skatta p genom olinjr optimering s att
%                   ||pflat(p*x) - pflat(y)|| minimeras.
% Utvariabler: alfa - Djupvektor. Radvektor.
%              p - projektionsmatris.
%              ya - korrigerad bild
%              xa - korrigerat objekt

if (nargin < 2),
  error('xytoalfap needs at least 2 arguments.');
elseif (nargin ==2)
 metod = 1;
end;

if metod == 1,
  [d,ok,singularvalues]=depthfromxandy(x,pflat(y));
  p=depth2proj(d,x,pflat(y));
  xa=x;
  p=p/norm(p);
  [ya,alfa]=pflat(p*x);
elseif metod == 2,
  [alfa,pin,xa,ya] = xy2alfap(x,y,1);
  p = skattaettP(x,pflat(y),pin);
  xa=x;
  p=p/norm(p);
  [ya,alfa]=pflat(p*x);
end;  
